package nl.iobyte.themeparkconnector;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import nl.iobyte.themepark.api.attraction.enums.Status;
import nl.iobyte.themeparkconnector.api.operator.adapter.OperatorItemAdapter;
import nl.iobyte.themeparkconnector.api.operator.adapter.OperatorPanelAdapter;
import nl.iobyte.themeparkconnector.api.operator.objects.panel.OperatorItem;
import nl.iobyte.themeparkconnector.api.operator.objects.panel.OperatorPanel;
import nl.iobyte.themeparkconnector.api.packet.adapter.PacketPayloadAdapter;
import nl.iobyte.themeparkconnector.api.packet.adapter.StatusAdapter;
import nl.iobyte.themeparkconnector.api.packet.objects.AbstractPacketPayload;

public class ThemeParkConnectorGson {

    public static Gson getInstance() {
        GsonBuilder builder = new GsonBuilder();

        //Packet
        builder.registerTypeAdapter(AbstractPacketPayload.class, new PacketPayloadAdapter())
                .registerTypeAdapter(Status.class, new StatusAdapter());

        //Operator
        builder.registerTypeAdapter(OperatorPanel.class, new OperatorPanelAdapter())
                .registerTypeAdapter(OperatorItem.class, new OperatorItemAdapter());

        return builder.create();
    }

}
