package nl.iobyte.themeparkconnector.api.load;

import nl.iobyte.themeparkconnector.api.load.interfaces.IDataLoader;
import nl.iobyte.themeparkconnector.api.load.objects.*;
import java.util.ArrayList;
import java.util.List;

public class DataLoadService {

    private final List<IDataLoader> loaders = new ArrayList<>();

    public DataLoadService() {
        addLoader(new DatabaseLoader());
        addLoader(new OperatorDataLoader());
    }

    /**
     * Add IDataLoader
     * @param dataLoader IDataLoader
     */
    public void addLoader(IDataLoader dataLoader) {
        loaders.add(dataLoader);
    }

    /**
     * Call all IDataLoaders
     */
    public void init() {
        for(IDataLoader loader : loaders)
            loader.load();
    }

}
