package nl.iobyte.themeparkconnector.commands;

import nl.iobyte.commandapi.CommandFactory;
import nl.iobyte.commandapi.middlewares.PermissionMiddleware;
import nl.iobyte.themeparkconnector.ThemeParkConnector;
import nl.iobyte.themeparkconnector.commands.subcommands.*;
import nl.iobyte.themeparkconnector.commands.subcommands.operator.OperatorCommands;

public class ThemeParkConnectorCommand {

    //Load command data
    public ThemeParkConnectorCommand() {
        CommandFactory factory = new CommandFactory("themeparkconnector");
        factory.addSubCommand(new HelpCommand(factory))
                .addSubCommand(new ConnectCommand());

        //Admin
        factory.addSubCommand(new StatusCommand())
                .addSubCommand(new NotificationCommand())
                .addSubCommand(new DisconnectCommand());

        //Operator
        OperatorCommands.load(factory);

        //Middleware
        factory.addMiddleware(new PermissionMiddleware());

        //Register command
        factory.registerCommand(ThemeParkConnector.getInstance());
    }

}
