package nl.iobyte.themeparkconnector.commands.subcommands;

import nl.iobyte.commandapi.interfaces.SubCommand;
import nl.iobyte.themepark.api.attraction.objects.Attraction;
import nl.iobyte.themepark.commands.arguments.AttractionArgument;
import nl.iobyte.themeparkconnector.ThemeParkConnector;
import nl.iobyte.themeparkconnector.api.client.ClientConnection;
import nl.iobyte.themeparkconnector.api.message.Text;
import nl.iobyte.themeparkconnector.api.operator.objects.AttractionOperator;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import java.util.List;

public class ConnectCommand extends SubCommand {

    public ConnectCommand() {
        super(new String[]{"connect"});

        addSyntax("/themeparkconnector connect <attraction>")
                .addArgument(new AttractionArgument())
                .setAllowConsole(false);
    }

    //Attempt to generate an url for the Player
    public void onPlayerCommand(Player player, List<Object> list, int i) {
        Attraction attraction = (Attraction) list.get(0);
        AttractionOperator operator = ThemeParkConnector.getInstance().getAPI().getOperatorService().getOperator(attraction.getID());
        if(operator == null) {
            player.sendMessage(Text.color("&6&lThemeParkConnectorMC &f➢ &4There is no operator for this attraction"));
            return;
        }

        ClientConnection client = ThemeParkConnector.getInstance().getAPI().getNetworkingService().getClient(
                player.getUniqueId()
        );
        if(!operator.canClientConnect(client)) {
            player.sendMessage(Text.color("&6&lThemeParkConnectorMC &f➢ &4You can't connect to the operator of this attraction"));
            return;
        }

        client.publishURL(attraction.getID());
    }

    public void onConsoleCommand(CommandSender commandSender, List<Object> list, int i) { }

}
