package nl.iobyte.themeparkconnector.commands.subcommands;

import nl.iobyte.commandapi.interfaces.SubCommand;
import nl.iobyte.themeparkconnector.ThemeParkConnector;
import nl.iobyte.themeparkconnector.api.ThemeParkConnectorAPI;
import nl.iobyte.themeparkconnector.api.message.Text;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import java.util.List;

public class DisconnectCommand extends SubCommand {

    public DisconnectCommand() {
        super("themeparkconnector.admin", "disconnect");

        addSyntax("/themeparkconnector disconnect");
    }

    //Attempt to generate an url for the Player
    public void onPlayerCommand(Player player, List<Object> list, int i) {
        onConsoleCommand(player, list, i);
    }

    public void onConsoleCommand(CommandSender sender, List<Object> list, int i) {
        ThemeParkConnectorAPI api = ThemeParkConnector.getInstance().getAPI();
        try {
            if (api.getStateService().isConnected())
                api.getNetworkingService().stop();
        } catch (Exception e) {
            e.printStackTrace();
            sender.sendMessage(Text.color("&6&lThemeParkConnectorMC &f➢ &4Something went wrong while closing connection"));
            return;
        }

        sender.sendMessage(Text.color("&6&lThemeParkConnectorMC &f➢ &aConnection has been closed"));
    }

}
