package nl.iobyte.themeparkconnector.commands.subcommands;

import nl.iobyte.commandapi.arguments.MessageArgument;
import nl.iobyte.commandapi.arguments.PlayersArgument;
import nl.iobyte.commandapi.interfaces.SubCommand;
import nl.iobyte.themeparkconnector.ThemeParkConnector;
import nl.iobyte.themeparkconnector.api.message.Text;
import nl.iobyte.themeparkconnector.api.client.ClientConnection;
import nl.iobyte.themeparkconnector.api.client.objects.Notification;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import java.util.List;

public class NotificationCommand extends SubCommand {

    public NotificationCommand() {
        super("themeparkconnector.admin", "notification");

        addSyntax("/themeparkconnector notification <player> <title> <message>")
                .addArgument(new PlayersArgument())
                .addArgument(new MessageArgument())
                .addArgument(new MessageArgument());
    }

    public void onPlayerCommand(Player player, List<Object> objects, int i) {
        onConsoleCommand(player, objects, i);
    }

    //Get Notification data and send to Player(s)
    public void onConsoleCommand(CommandSender sender, List<Object> objects, int i) {
        Notification notification = new Notification((String) objects.get(1), (String) objects.get(2));
        for(Player player : (List<Player>) objects.get(0)) {
            ClientConnection client = ThemeParkConnector.getInstance().getAPI().getNetworkingService().getClient(player.getUniqueId());
            if(!client.isConnected())
                continue;

            i++;
            notification.send(client);
        }

        sender.sendMessage(Text.color("&6&lThemeParkConnectorMC &f➢ The notification has been send to &6"+i+" &fclients"));
    }

}
