package nl.iobyte.themeparkconnector.listeners;

import net.md_5.bungee.api.ChatColor;
import net.md_5.bungee.api.chat.BaseComponent;
import net.md_5.bungee.api.chat.ClickEvent;
import net.md_5.bungee.api.chat.TextComponent;
import nl.iobyte.themepark.ThemePark;
import nl.iobyte.themepark.api.attraction.objects.Attraction;
import nl.iobyte.themepark.api.message.MessageKey;
import nl.iobyte.themepark.utils.LocationUtil;
import nl.iobyte.themeparkconnector.ThemeParkConnector;
import nl.iobyte.themeparkconnector.api.config.enums.StorageKey;
import nl.iobyte.themeparkconnector.api.message.Text;
import nl.iobyte.themeparkconnector.api.operator.objects.AttractionOperator;
import org.bukkit.Bukkit;
import org.bukkit.block.Block;
import org.bukkit.block.Sign;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.block.Action;
import org.bukkit.event.block.SignChangeEvent;
import org.bukkit.event.player.PlayerInteractEvent;

public class RideOperatorListener implements Listener {

    @EventHandler
    public void onPlace(SignChangeEvent e) {
        if(e.getLines().length < 2)
            return;

        if(!e.getLine(0).equalsIgnoreCase(ThemeParkConnector.getInstance().getAPI().getConfigurationManager().getString(StorageKey.SIGN_CONTROL_NAME)))
            return;

        String id = e.getLine(1);
        if(!ThemePark.getInstance().getAPI().getAttractionService().hasAttraction(id)) {
            e.getPlayer().sendMessage(Text.color("&6&lThemeParkConnectorMC &f➢ &4There is no attraction with ID: &f"+id));
            return;
        }

        if(!ThemeParkConnector.getInstance().getAPI().getOperatorService().hasOperator(id)) {
            e.getPlayer().sendMessage(Text.color("&6&lThemeParkConnectorMC &f➢ &4There is no operator for this attraction"));
            return;
        }

        e.setLine(0, Text.color(ThemeParkConnector.getInstance().getAPI().getConfigurationManager().getString(StorageKey.SIGN_CONTROL_TITLE)));
        e.getPlayer().sendMessage(Text.color("&6&lThemeParkConnectorMC &f➢ &aSuccessfully made an operator sign"));
    }

    @EventHandler
    public void onClick(PlayerInteractEvent e) {
        if(e.getAction() == Action.LEFT_CLICK_AIR || e.getAction() == Action.RIGHT_CLICK_AIR)
            return;

        if(e.getClickedBlock() == null)
            return;

        Block block = e.getClickedBlock();
        if(!(block.getState() instanceof Sign))
            return;

        Sign sign = (Sign) block.getState();
        if(!ChatColor.stripColor(sign.getLine(0)).equals(Text.color(ThemeParkConnector.getInstance().getAPI().getConfigurationManager().getString(StorageKey.SIGN_CONTROL_TITLE))))
            return;

        String id = ChatColor.stripColor(sign.getLine(1));
        if(id == null || id.isEmpty())
            return;

        Player player = e.getPlayer();
        if(!ThemePark.getInstance().getAPI().getAttractionService().hasAttraction(id)) {
            player.sendMessage(Text.color("&6&lThemeParkConnectorMC &f➢ &4No attraction with ID: &f"+id));
            return;
        }

        Bukkit.dispatchCommand(player, "/tpc connect "+id);
    }

}
